/*
	$Id: Strings.java 321 2007-05-25 14:23:03Z syl $

	Copyright (C) 2006 Syllabub
	Maroontress Fast Software.
*/

package com.maroontress.sanctuary;

/**
   ȴάʸǤ
*/
public final class Strings {

    /** ʸδ */
    private String qualified;

    /** ʸδά */
    private String simple;

    /**
       ʸޤ

       @param qualified ʸ
       @param simple άʸ
    */
    private Strings(final String qualified, final String simple) {
	this.qualified = qualified;
	this.simple = simple;
    }

    /**
       ȴάʸޤ

       @param qualified ʸ
    */
    private Strings(final String qualified) {
	this.qualified = qualified;
	this.simple = qualified;
    }

    /**
       ʸޤ

       @param qualified ʸ
       @param simple άʸ
       @return ʸ
    */
    public static Strings intern(final String qualified, final String simple) {
	return new Strings(qualified, simple);
    }

    /**
       ȴάʸޤ

       @param s ʸ
       @return ʸ
    */
    public static Strings intern(final String s) {
	return new Strings(s);
    }

    /**
       Ƭꤷʸޤ

       @param prefix Ƭ
       @param s ʸ
       @return ʸ
    */
    public static Strings prepend(final String prefix, final Strings s) {
	return new Strings(prefix + s.qualified, prefix + s.simple);
    }

    /**
       ꤷʸޤ

       @param s ʸ
       @param suffix 
       @return ʸ
    */
    public static Strings append(final Strings s, final String suffix) {
	return new Strings(s.qualified + suffix, s.simple + suffix);
    }

    /**
       ʸδޤ

       @return ʸ
    */
    public String getQualified() {
	return qualified;
    }

    /**
       ʸδάޤ

       @return άʸ
    */
    public String getSimple() {
	return simple;
    }

    /**
       {@inheritDoc}

       Ϥʸޤ
    */
    @Override public String toString() {
	return qualified;
    }
}
